%bcond_without full
%bcond_without imagemagick
%bcond_without extdvdnav
%bcond_with    embedded_ffmpeg

%define         abiver   1.30
%define         plugind  %{_libdir}/xine/plugins/%{abiver}
%define         codecdir %{_libdir}/codecs
%ifarch %{ix86}
%define         have_vidix 1
%else
%define         have_vidix 0
%endif

Summary:        Xine library
Name:           xine-lib
Version:        1.1.21
Release:        25%{?dist}
License:        GPLv2+
Group:          System Environment/Libraries
URL:            http://www.xine-project.org/home
Patch0:		xine-lib-1.1.19-no_autopoint.patch
Source0:        http://prdownloads.sourceforge.net/xine/%{name}-%{version}.tar.xz
Patch1:         %{name}-1.1.4-optflags.patch

Patch6:         %{name}-1.1.17-deepbind-939.patch
# http://bugzilla.redhat.com/470568
Patch8:         xine-lib-1.1.17-avsync_hack.patch
# http://bugzilla.redhat.com/477226
Patch9:         xine-lib-1.1.16.2-multilib.patch
Patch10:	xine-lib-1.1.21-samba4.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: gettext
BuildRequires: perl, cvs
BuildRequires: libstdc++-devel
BuildRequires: gnome-vfs2-devel 
BuildRequires: gtk2-devel
Buildrequires: libdc1394-devel
## samba-common in <= FC-6, libsmbclient-devel in FC7+
#BuildRequires: %{_includedir}/libsmbclient.h
BuildRequires: libsmbclient-devel
BuildRequires: automake, libtool
BuildRequires: pkgconfig 
Buildrequires: vcdimager-devel
Buildrequires: zlib-devel
# X11
BuildRequires: libGLU-devel
BuildRequires: libXext-devel
BuildRequires: libX11-devel 
BuildRequires: libXv-devel 
BuildRequires: libXvMC-devel 
BuildRequires: libXinerama-devel 
# Video
BuildRequires: aalib-devel >= 1.4
%{?with_full:BuildRequires: libcaca-devel >= 0.99}
BuildRequires: libmng-devel
BuildRequires: libtheora-devel 
BuildRequires: SDL-devel 
BuildRequires: directfb-devel
BuildRequires: fontconfig-devel
%{!?with_embedded_ffmpeg:BuildRequires: ffmpeg-devel >= 0.4.9}
%{!?with_imagemagick:BuildRequires: ImageMagick-devel >= 6.2.4.6-1}
BuildRequires: libfame-devel
%{?with_extdvdnav:BuildRequires: libdvdnav-devel >= 0.1.4}
BuildRequires: libdvdread-devel
BuildRequires: libxcb-devel
# Audio
BuildRequires: alsa-lib-devel >= 0.9.0
BuildRequires: arts-devel 
Buildrequires: a52dec-devel
BuildRequires: faad2-devel
BuildRequires: flac-devel 
BuildRequires: esound-devel 
BuildRequires: jack-audio-connection-kit-devel 
Buildrequires: libdca-devel
Buildrequires: libmad-devel
%{?with_full:BuildRequires: libmpcdec-devel}
BuildRequires: libogg-devel 
BuildRequires: libvorbis-devel 
%{?with_full:BuildRequires: libmodplug-devel}
%{?with_full:BuildRequires: pulseaudio-libs-devel}
BuildRequires: speex-devel 
%{?with_full:BuildRequires: wavpack-devel}

Provides:  xine-lib(plugin-abi) = %{abiver}
Provides:  xine-lib-extras = %{version}-%{release}
Provides:  xine-lib-moles = %{version}-%{release}
Provides:  xine-lib-extras-nonfree = %{version}-%{release}
Provides:  xine-lib-extras-freeworld = %{version}-%{release}
Provides:  xine-lib-pulseaudio = %{version}-%{release}
Obsoletes: xine-lib-extras < %{version}-%{release}
Obsoletes: xine-lib-moles < %{version}-%{release}
Obsoletes: xine-lib-extras-nonfree < %{version}-%{release}
Obsoletes: xine-lib-extras-freeworld < %{version}-%{release}
Obsoletes: xine-lib-pulseaudio < %{version}-%{release}

%description
Xine is a free multimedia player.
It plays back CDs, DVDs, and VCDs. It also decodes multimedia files
from local disk drives, and displays multimedia streamed over the Internet. 
It interprets many of the most common multimedia formats available 
- and some of the most uncommon formats, too.  
This package contains the Xine library. 

%package devel
Summary:         Xine library development files
Group:           Development/Libraries
Requires:        %{name} = %{version}-%{release}
Requires:        pkgconfig zlib-devel

%description devel
This package contains development files for xine-lib.

%prep
%setup -q

touch -r configure.ac aclocal.m4
touch -r m4/optimizations.m4 m4/optimizations.m4.stamp
%patch1 -p1 -b .optflags
%patch0 -p1 -b .no_autopoint
touch -r m4/optimizations.m4.stamp m4/optimizations.m4
# Patch6 needed at least when compiling with external ffmpeg, #939.
%patch6 -p1 -b .deepbind
%patch8 -p1 -b .avsync_hack
%patch9 -p1 -b .multilib
%patch10 -p1 -b .samba4

# Avoid standard rpaths on lib64 archs:
sed -i -e 's|"/lib /usr/lib\b|"/%{_lib} %{_libdir}|' configure
./autogen.sh noconfig

%build
%configure \
    --disable-rpath \
    --disable-dependency-tracking \
    --enable-ipv6 \
    --with-xv-path=%{_libdir} \
    --with-w32-path=%{codecdir} \
    --with-real-codecs-path=%{codecdir} \
    --with-arts \
    --with-external-a52dec \
    --with-libflac \
    --with-external-libmad \
    %{?with_full:--with-external-libmpcdec} \
    %{!?with_full:--without-pulseaudio} \
    --with-external-libdts \
    %{?with_full:--with-wavpack} \
    --enable-antialiasing \
    --enable-directfb \
    %{?with_embedded_ffmpeg:--with-external-ffmpeg=no} \
    --with-freetype --with-fontconfig \
    %{!?with_imagemagick:--without-imagemagick} \
    %{!?with_extdvdnav:--with-included-dvdnav}

make %{?_smp_mflags}


%install
rm -rf %{buildroot} __docs
make install DESTDIR=%{buildroot}
%find_lang libxine1
cp -pR %{buildroot}%{_docdir}/xine-lib __docs
rm -rf %{buildroot}%{_docdir}/xine-lib

# Removing useless files
rm -Rf %{buildroot}%{_libdir}/libxine.la __docs/README \
       __docs/README.{freebsd,irix,solaris,MINGWCROSS,WIN32} \
       __docs/README.{dxr3,network_dvd}


# Directory for binary codecs
mkdir -p %{buildroot}%{codecdir}


%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files -f libxine1.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING COPYING.LIB CREDITS ChangeLog* README TODO
%doc __docs/README.* __docs/faq.*
%dir %{codecdir}/
%{_datadir}/xine/
%{_libdir}/libxine.so.*
%{_mandir}/man5/xine.5*

%dir %{plugind}/
%{plugind}/*.so
%{plugind}/mime.types
%{plugind}/post
%if %{have_vidix}
%{plugind}/vidix
%endif

%files devel
%defattr(-,root,root,-)
%doc __docs/hackersguide/*
%{_bindir}/xine-config
%{_bindir}/xine-list-1.1
%{_datadir}/aclocal/xine.m4
%{_includedir}/xine.h
%{_includedir}/xine/
%{_libdir}/libxine.so
%{_libdir}/pkgconfig/libxine.pc
%{_mandir}/man1/xine-config.1*
%{_mandir}/man1/xine-list-1*

%changelog
* Sat Jun 23 2012 Paulo Roma <roma@lcg.ufrj.br> - 1.1.21-24%{?dist}
- Updated to 1.1.21
- Added --disable-rpath

* Sat Mar 10 2012 Paulo Roma <roma@lcg.ufrj.br> - 1.1.20.1-23%{?dist}
- Updated to 1.1.20.1
- Removed autotools.patch and external ffmpeg hack.

* Sun Sep 05 2010 Paulo Roma <roma@lcg.ufrj.br> - 1.1.19-22%{?dist}
- Updated to 1.1.19
- Added BR libdvdread-devel.

* Sat Apr 10 2010 Paulo Roma <roma@lcg.ufrj.br> - 1.1.18.1-21
- Updated to 1.1.18.1
- Fixed URL.

* Sat Dec 12 2009 Paulo Roma <roma@lcg.ufrj.br> - 1.1.17-20
- Updated to 1.1.17
- Adapted deepbind-939.patch

* Fri Jul 17 2009 Paulo Roma <roma@lcg.ufrj.br> - 1.1.16.3-19
- Rewritten build conditions for RHLE5.

* Tue Apr 14 2009 Paulo Roma <roma@lcg.ufrj.br> - 1.1.16.3-18
- Updated to 1.1.16.3
- Removed already applied patch100.
- ABIver 1.26

* Sun Mar 22 2009 Paulo Roma <roma@lcg.ufrj.br> - 1.1.16.2-17
- Updated to 1.1.16.2
- Replaced sed for autogen.sh for removing rpaths.
- Applied patch100.

* Thu Jan 15 2009 Paulo Roma <roma@lcg.ufrj.br> - 1.1.16.1-16
- Updated to 1.1.16.1
- Removed patch2 (ansi).

* Sun Nov 30 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.15-15
- Obsoleting xine-lib-pulseaudio.

* Mon Nov 24 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.14-15
- Applying ffmpeg patch on only two directories.

* Thu Nov 20 2008 Axel Thimm <Axel.Thimm@ATrpms.net> - 1.1.15-13
- Fix build against recent ffmpeg API changes.

* Mon Nov 17 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.15-12
- No more listing all files in plugind explicitly.
- Dropped xine-lib-extras.

* Thu Nov 13 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.15-11
- Providing and Obsoleting xine-lib-extras-freeworld.

* Fri Aug 15 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.15-10
- Updated to 1.1.15
- Added BR libdca.
- Removed export FFMPEG_CFLAGS and export FFMPEG_POSTPROC_CFLAGS
  before configuring (otherwise the compilation failed).
- Removed export SDL_CFLAGS.
- Applied patch2 (ansi).
- Upstreaming is using external ffmpeg and libfaad by default.

* Fri Jul 04 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.14-9
- Updated to 1.1.14

* Sun Jun 15 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.13-9
- Updated to 1.1.13
- Added BR libtool.

* Fri Apr 17 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.12-8
- Using bcond_without for optional BRs.

* Tue Apr 15 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.12-7
- Updated to 1.1.12
- Removed some %%dir, which were duplicates.  

* Thu Apr 03 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.11.1-6
- Updated to 1.1.11.1
- This release contains a security fix:
  (integer overflow, possibly leading to buffer overflow, CVE-2008-1482)

* Fri Mar 21 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.11-6
- Updated to 1.1.11

* Fri Feb 09 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.10.1-6
- Updated to 1.1.10.1
- Fixes an index vulnerability which may lead to 
  a stack buffer overflow, CVE-2008-0486.
- Using %%{plugind} because plugins are in 1.1.10 subdir.

* Tue Jan 29 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.10-5
- Updated to 1.1.10.

* Tue Jan 15 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.9.1-5
- Updated to 1.1.9.1.
- Removed multilib-devel.patch

* Sat Jan 12 2008 Paulo Roma <roma@lcg.ufrj.br> - 1.1.9-5
- Updated to 1.1.9.
- Added BR libxcb-devel.

* Sat Nov 10 2007 Paulo Roma <roma@lcg.ufrj.br> - 1.1.8-4_1
- Rebuilt for Fedora 8.
- Added xineplug_vo_out_xcbshm.so and xineplug_vo_out_xcbxv.so

* Fri Oct 05 2007 Paulo Roma <roma@lcg.ufrj.br> - 1.1.8-1
- Updated to 1.1.8.

* Sat Jun 16 2007 Paulo Roma <roma@lcg.ufrj.br> - 1.1.7-1
- Rebuilt for Fedora 6.

* Thu Jun  7 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.7-1
- 1.1.7.

* Wed Apr 25 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.6-2
- Make Real codec search path /usr/lib(64)/codecs again (#237743).

* Wed Apr 18 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.6-1
- 1.1.6.

* Wed Apr 11 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.5-1
- 1.1.5.
- Include GSM 06.10 decoder (#228186).
- Re-enable CACA support.

* Sun Apr  8 2007 Ville Skyttä <ville.skytta at iki.fi>
- Exclude vidix dir on systems that don't have vidix.
- Specfile cleanups.

* Mon Mar 26 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.4-4
- Add PulseAudio support (in -extras, #234035/Jost Diederichs).
- Adjust Samba build dependencies to work for both <= and > FC6.
- Add --with freetype and --with antialiasing build time options,
  default disabled, and an upstream patch for FreeType memory leak (#233194).

* Sat Mar 10 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.4-3
- Apply upstream fix for CVE-2007-1246.

* Wed Feb 14 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.4-2
- Rebuild.

* Wed Jan 31 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.4-1
- 1.1.4, with wavpack and system libmpcdec support.

* Thu Jan 18 2007 Aurelien Bompard <abompard@fedoraproject.org> 1.1.3-4
- rebuild

* Wed Jan  3 2007 Ville Skyttä <ville.skytta at iki.fi> - 1.1.3-3
- Fix libflac decoder with FLAC < 1.1.3 (#220961).
- Apply upstream patch for FLAC >= 1.1.3.

* Sun Dec 17 2006 Ville Skyttä <ville.skytta at iki.fi> - 1.1.3-2
- Don't run autotools during build.

* Mon Dec 04 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.1.3-1
- version 1.1.3
- patch2 applied upstream
- Disable CACA support by default, needs newer than what's in FE ATM.
- Split extras plugins in a separate package
- Enable JACK support (in extras subpackage)
- Enable DirectFB support (in extras subpackage)

* Sat Nov 11 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.1.2-18
- Make shn files available to amarok. References:
  http://xine.cvs.sourceforge.net/xine/xine-lib/src/demuxers/demux_shn.c?r1=1.1.2.2&r2=1.2
  https://launchpad.net/distros/ubuntu/+source/xine-lib/+bug/63130

* Wed Oct 18 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.1.2-17
- cleanup docs
- remove mms
- delete more source files in the cleanup script
- drop patch3 (affecting mms)

* Tue Oct 17 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.1.2-16
- fix files list
- add BR gtk2-devel
- remove xineplug_decode_gdk_pixbuf.so from x86-only

* Mon Oct 16 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.1.2-15
- removed libdts
- drop dxr patch (it's removed from tarball)
- list xineplug_decode_gdk_pixbuf.so and xineplug_vo_out_vidix.so only on x86

* Sun Oct 15 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.1.2-14
- update SOURCE1 to remove liba52 from tarball (patented)

* Tue Sep 12 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.1.2-13
- drop patches 2 and 4

* Fri Sep 08 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.1.2-12
- initial Fedora Extras package
